--[[

	PuzzleShuffle v0.2
	by luckymouse

]]--

function str_explode(text, needle)
	local array={}
	_, count = string.gsub(text, needle, needle)
	for index=1,count+1 do
		i, j = string.find(text, needle)
		if i == nil or j==nil then
			i=0
			j=0
		end
	  table.insert(array,string.sub(text, 1, i-1))
		text=string.sub(text, j+1 )
  end
  return array
end

function in_table(array,string)

	array_len = table.getn(array)

	busted = 0
	for i=1,array_len do
		if string.lower(array[i]) == string.lower(string) then
			busted = 1
		else
		end
	end

	return busted

end

function round(num, idp)

	local mult = 10^(idp or 0)

	return math.floor(num * mult + 0.5) / mult

end

function timeplayed (timef)

	--hours
	n_hours = math.floor(timef / 3600)
	
	if n_hours < 10 then
		nr_hours = "0"..n_hours
	else
		nr_hours = n_hours
	end	

	--minutes
	n_minutes = math.floor(((timef / 3600) - n_hours) * 60)

	if n_minutes < 10 then
		nr_minutes = "0"..n_minutes
	else
		nr_minutes = n_minutes
	end

	--seconds
	n_seconds = ((((timef / 3600) - n_hours) * 60) - n_minutes) * 60

	if round(n_seconds,1) < 10 then
		nr_seconds = "0"..round(n_seconds,1)
	else
		nr_seconds = round(n_seconds,1)
	end


	return nr_hours.."."..nr_minutes.."."..nr_seconds

end

function openfile (file)

	local f = assert(io.open(file, "r"))
	local c = f:read("*all")
	f:close()

	file_array = {}
	file_array = str_explode(c, '\r\n')

	array_length = table.getn(file_array)

	if file_array[array_length] == "" then
		table.remove(file_array,array_length)
	end

	return file_array

end

function loadfile (file)

	local f = assert(io.open(file, "r"))
	local c = f:read("*all")
	f:close()

	file_array = {}
	file_array = str_explode(c, '\r\n')

	array_length = table.getn(file_array)

	if file_array[array_length] == "" then
		table.remove(file_array,array_length)
	end

	return file_array

end

function numb_puzzles (array)

	array_size = table.getn(array)
	n_puzzles = array_size

	return n_puzzles

end

function savecheck (number2check)

	file = "Saves/s"..number2check.."/"..n_tiles[menu_hor[1]].."-"..n_tiles[menu_hor[2]]..".sav"
	
	if io.open(file, "r") then
		return_val = "yes"
		return return_val
	else
		return_val = "no"
		return return_val
	end

end

function thumb_numb(number)
	if number < 10 then
		number = "00"..number
		return number
	elseif number > 9 and number < 100 then
		number = "0"..number
		return number
	elseif number > 99 then
		return number
	end
end

function createfile (filename)

	local f = assert(io.open(filename, "w"))
	f:close()	

end

function loadinput ()

	fancy_grey   = Color.new(179,114,20)
	fancy_grey_d = Color.new(179,114,20)
	fancy_white  = Color.new(217,185,138)

	Blank_in = Image.createEmpty(114,114)
	Blank_in:clear(fancy_grey)
	
	Blank_select = Image.createEmpty(38,38)
	Blank_select:clear(fancy_white)

	abc = {}
	abc[1] = {}
	abc[1][1] = {}
	abc[1][2] = {}
	abc[1][3] = {}
	abc[2] = {}
	abc[2][1] = {}
	abc[2][2] = {}
	abc[2][3] = {}
	abc[3] = {}
	abc[3][1] = {}
	abc[3][2] = {}
	abc[3][3] = {}

	abc[1][1][1] = "a"
	abc[1][1][2] = "1"
	abc[1][1][3] = "c"
	abc[1][1][4] = "b"
	abc[1][1][5] = "A"
	abc[1][1][6] = " "
	abc[1][1][7] = "C"
	abc[1][1][8] = "B"

	abc[1][1][9]  = "!"
	abc[1][1][10] = "@"
	abc[1][1][11] = "#"
	abc[1][1][12] = "$"


	abc[1][2][1] = "j"
	abc[1][2][2] = "4"
	abc[1][2][3] = "l"
	abc[1][2][4] = "k"
	abc[1][2][5] = "J"
	abc[1][2][6] = " "
	abc[1][2][7] = "L"
	abc[1][2][8] = "K"

	abc[1][2][9]  = "+"
	abc[1][2][10] = "="
	abc[1][2][11] = "|"
	abc[1][2][12] = "\\"


	abc[1][3][1] = "s"
	abc[1][3][2] = "7"
	abc[1][3][3] = "u"
	abc[1][3][4] = "t"
	abc[1][3][5] = "S"
	abc[1][3][6] = " "
	abc[1][3][7] = "U"
	abc[1][3][8] = "T"

	abc[1][3][9]  = "?"
	abc[1][3][10] = "/"
	abc[1][3][11] = "."
	abc[1][3][12] = ">"


	abc[2][1][1] = "d"
	abc[2][1][2] = "2"
	abc[2][1][3] = "f"
	abc[2][1][4] = "e"
	abc[2][1][5] = "D"
	abc[2][1][6] = " "
	abc[2][1][7] = "F"
	abc[2][1][8] = "E"

	abc[2][1][9]  = "%"
	abc[2][1][10] = "^"
	abc[2][1][11] = "&"
	abc[2][1][12] = "*"


	abc[2][2][1] = "m"
	abc[2][2][2] = "5"
	abc[2][2][3] = "o"
	abc[2][2][4] = "n"
	abc[2][2][5] = "M"
	abc[2][2][6] = " "
	abc[2][2][7] = "O"
	abc[2][2][8] = "N"

	abc[2][2][9]  = "}"
	abc[2][2][10] = "]"
	abc[2][2][11] = "{"
	abc[2][2][12] = "["


	abc[2][3][1] = "v"
	abc[2][3][2] = "8"
	abc[2][3][3] = "x"
	abc[2][3][4] = "w"
	abc[2][3][5] = "V"
	abc[2][3][6] = " "
	abc[2][3][7] = "X"
	abc[2][3][8] = "W"

	abc[2][3][9]  = ","
	abc[2][3][10] = "<"
	abc[2][3][11] = "~"
	abc[2][3][12] = "`"


	abc[3][1][1] = "g"
	abc[3][1][2] = "3"
	abc[3][1][3] = "i"
	abc[3][1][4] = "h"
	abc[3][1][5] = "G"
	abc[3][1][6] = " "
	abc[3][1][7] = "I"
	abc[3][1][8] = "H"

	abc[3][1][9]  = "("
	abc[3][1][10] = ")"
	abc[3][1][11] = "_"
	abc[3][1][12] = "-"


	abc[3][2][1] = "p"
	abc[3][2][2] = "6"
	abc[3][2][3] = "r"
	abc[3][2][4] = "q"
	abc[3][2][5] = "P"
	abc[3][2][6] = " "
	abc[3][2][7] = "R"
	abc[3][2][8] = "Q"

	abc[3][2][9]  = "\""
	abc[3][2][10] = "'"
	abc[3][2][11] = ";"
	abc[3][2][12] = ":"

	abc[3][3][1] = "y"
	abc[3][3][2] = "9"
	abc[3][3][3] = "z"
	abc[3][3][4] = "0"
	abc[3][3][5] = "Y"
	abc[3][3][6] = " "
	abc[3][3][7] = "Z"
	abc[3][3][8] = " "

	abc[3][3][9]  = " "
	abc[3][3][10] = " "
	abc[3][3][11] = " "
	abc[3][3][12] = " "


end



function input(string,x,y) 

	--setting the start values
	key_mode_x = 2
	key_mode_y = 2


	--handling the pressed keys, yes... 
	if pad:analogX() > 120 then
		key_mode_x = 3
		key_mode_y = 2
	end
	if pad:analogX() < -120 then
		key_mode_x = 1
		key_mode_y = 2
	end
	if pad:analogY() < -120 then
		key_mode_x = 2
		key_mode_y = 1
	end
	if pad:analogY() > 120 then
		key_mode_x = 2
		key_mode_y = 3
	end
	if pad:analogX() > 90 and pad:analogY() < -90 then
		key_mode_x = 3
		key_mode_y = 1
	end
	if pad:analogX() > 90 and pad:analogY() > 90 then
		key_mode_x = 3
		key_mode_y = 3
	end
	if pad:analogX() < -90 and pad:analogY() < -90 then
		key_mode_x = 1
		key_mode_y = 1
	end
	if pad:analogX() < -90 and pad:analogY() > 90 then
		key_mode_x = 1
		key_mode_y = 3
	end
	if ((pad:down() ~= oldpad:down()) and pad:down()) then
		--normal characters
		upper = 0
	end
	if ((pad:up() ~= oldpad:up()) and pad:up()) then
		--upper case
		upper = 4
	end
	if ((pad:left() ~= oldpad:left()) and pad:left()) then
		--special characters
		upper = 8
	end

	--showing the keyboard
	screen:blit(x-5,y-5,Blank_in,true)
	screen:blit(x-5+((key_mode_x - 1)*38),y-5+((key_mode_y - 1)*38),Blank_select,true)

	screen:print(x,y+10,abc[1][1][upper+1],black)
	screen:print(x+10,y,abc[1][1][upper+2],black)
	screen:print(x+20,y+10,abc[1][1][upper+3],black)
	screen:print(x+10,y+20,abc[1][1][upper+4],black)

	screen:print(x,y+50,abc[1][2][upper+1],black)
	screen:print(x+10,y+40,abc[1][2][upper+2],black)
	screen:print(x+20,y+50,abc[1][2][upper+3],black)
	screen:print(x+10,y+60,abc[1][2][upper+4],black)

	screen:print(x,y+90,abc[1][3][upper+1],black)
	screen:print(x+10,y+80,abc[1][3][upper+2],black)
	screen:print(x+20,y+90,abc[1][3][upper+3],black)
	screen:print(x+10,y+100,abc[1][3][upper+4],black)

	screen:print(x+40,y+10,abc[2][1][upper+1],black)
	screen:print(x+50,y,abc[2][1][upper+2],black)
	screen:print(x+60,y+10,abc[2][1][upper+3],black)
	screen:print(x+50,y+20,abc[2][1][upper+4],black)

	screen:print(x+40,y+50,abc[2][2][upper+1],black)
	screen:print(x+50,y+40,abc[2][2][upper+2],black)
	screen:print(x+60,y+50,abc[2][2][upper+3],black)
	screen:print(x+50,y+60,abc[2][2][upper+4],black)

	screen:print(x+40,y+90,abc[2][3][upper+1],black)
	screen:print(x+50,y+80,abc[2][3][upper+2],black)
	screen:print(x+60,y+90,abc[2][3][upper+3],black)
	screen:print(x+50,y+100,abc[2][3][upper+4],black)

	screen:print(x+80,y+10,abc[3][1][upper+1],black)
	screen:print(x+90,y,abc[3][1][upper+2],black)
	screen:print(x+100,y+10,abc[3][1][upper+3],black)
	screen:print(x+90,y+20,abc[3][1][upper+4],black)

	screen:print(x+80,y+50,abc[3][2][upper+1],black)
	screen:print(x+90,y+40,abc[3][2][upper+2],black)
	screen:print(x+100,y+50,abc[3][2][upper+3],black)
	screen:print(x+90,y+60,abc[3][2][upper+4],black)

	screen:print(x+80,y+90,abc[3][3][upper+1],black)
	screen:print(x+90,y+80,abc[3][3][upper+2],black)
	screen:print(x+100,y+90,abc[3][3][upper+3],black)
	screen:print(x+90,y+100,abc[3][3][upper+4],black)

	--verwerken van de input
	if ((pad:l() ~= oldpad:l()) and pad:l()) then
		string_leng = string.len(string)
		if string_leng > 0 then
			string = string.sub(string,1,-2)
		end
	end
	if ((pad:cross() ~= oldpad:cross()) and pad:cross()) then
		string = string .. abc[key_mode_x][key_mode_y][upper+4]
		screen.waitVblankStart(5)
	end
	if ((pad:circle() ~= oldpad:circle()) and pad:circle()) then
		string = string .. abc[key_mode_x][key_mode_y][upper+3]
		screen.waitVblankStart(5)
	end
	if ((pad:square() ~= oldpad:square()) and pad:square()) then
		string = string .. abc[key_mode_x][key_mode_y][upper+1]
		screen.waitVblankStart(5)
	end
	if ((pad:triangle() ~= oldpad:triangle()) and pad:triangle()) then
		string = string .. abc[key_mode_x][key_mode_y][upper+2]
		screen.waitVblankStart(5)
	end

	if string.len(string) > 20 then
		string = string.sub(string,1,20)
	end

	return string

end