--[[

	PuzzleShuffle v0.2
	by luckymouse

]]--




black   = Color.new(0, 0, 0)
white   = Color.new(255, 255, 255)
white_1 = Color.new(250, 250, 250)
red     = Color.new(255,0,0)
yellow  = Color.new(255,255,0)

screen:clear(white)
screen.flip()

dofile("functions.lua")

oldpad = Controls.read()
background_custom = Image.load("Img/background_custom.png")
background_create = Image.load("Img/background_createfile.png")
selection_spacer  = Image.load("Img/selection_spacer.png")

img		  = {}
img_s		  = {}
savefileyn 	  = {}
pages_m     	  = {}

n_tiles		  = {4,5,10,13,20}
tile_modes	  = {"Closed","Spaced 2px","Spaced 1px"}
begin_tile	  = {"Transparent","Transparent Border"}
menu_n		  = {5,5,3,2}

load_custom 	  = 1
load_mode   	  = 1
selection   	  = 1
v_selection	  = 1
menu_hor	  = {1,1,1,1}

puzzle_data 	  = openfile("puzzles.txt")
puzzles     	  = numb_puzzles(puzzle_data)

mode 		  = 1

while true do
	--show puzzles
	if mode == 1 then
		while true do
			screen:clear()
			screen:blit(0,0,background_custom,true)
			screen:print(0,262,"Free ram: "..System.getFreeMemory(),black)
			pad = Controls.read()

			-- if the load_custom is not declared, declare it and do stuff
			if load_custom == 1 then

				screen:print(0,0,"Loading..",black)

				--If the load_start is not declared, declare it !
				if not load_start then
					load_start = 1
				end

				--deciding the number of pages
				pages = math.ceil(puzzles / 5)

				--Loading images that are used when one has 5 or more puzzles
				if puzzles > 1 then
					scroll_border = Image.load("Img/scroll_border.png")
					pip0 = 		Image.load("Img/pip0.png")
					pip1 = 		Image.load("Img/pip1.png")
				end

				--Loading backgrounds
				
				if load_start == pages and ((load_start-1)*5)+5 > puzzles then
					puzzles2load = puzzles - ((load_start-1)*5)
					for i=1,puzzles2load do
						img[i]   = Image.load("Img/thumb/t"..puzzle_data[(i+((load_start-1)*5))]..".png")
						img_s[i] = Image.load("Img/selection/s"..puzzle_data[(i+((load_start-1)*5))]..".png")
						--img[i]   = puzzle_data[(i+((load_start-1)*5))]
						--img_s[i] = puzzle_data[(i+((load_start-1)*5))]
						savefileyn[i] = savecheck(puzzle_data[(i+((load_start-1)*5))])
					end
				else
					--Loading the Backgrounds
					puzzles2load = 5
					for i=1,puzzles2load do
						img_s[i]      = Image.load("Img/selection/s"..puzzle_data[(i+((load_start-1)*5))]..".png")
						img[i]        = Image.load("Img/thumb/t"..puzzle_data[(i+((load_start-1)*5))]..".png")
						--img[i]   = puzzle_data[(i+((load_start-1)*5))]
						--img_s[i] = puzzle_data[(i+((load_start-1)*5))]
						savefileyn[i] = savecheck(puzzle_data[(i+((load_start-1)*5))])
					end
				end
				

				load_custom = 2

			elseif load_custom == 2 then

				--refresh purpose only >_>
				menu = {n_tiles[menu_hor[1]],n_tiles[menu_hor[2]],tile_modes[menu_hor[3]],begin_tile[menu_hor[4]]}

				--blitting the scrollbar + pips !
				if pages > 1 then
					screen:blit(218,15,scroll_border,true)
					for i=1,pages do
						screen:blit(221,20+((i-1)*5),pip1,true)
					end
					screen:blit(221,20+((load_start-1)*5),pip0,true)
				end
				--blitting the mini images !
				for i=1,puzzles2load do
					if i > selection or i < selection then
						screen:blit(17,17+((i-1)*22),img_s[i],true)
						--screen:print(17,17+((i-1)*22),img_s[i],black)
					end
				end

				screen:blit(31,17,selection_spacer,true)
				screen:blit(17,17+((selection-1)*22),img_s[selection],true)
				--screen:print(17,17+((selection-1)*22),img_s[selection],black)
				screen:blit(25,142,img[selection],true)
				--screen:print(25,142,img[selection],black)

				screen:print(254,17,puzzle_data[(((load_start-1)*5)+selection)],black)

				screen:print(254,27,"__________________________",black)

				screen:print(254,37,"Number of X tiles",black)
				screen:print(259,47,menu[1],black)
				screen:print(254,57,"Number of Y tiles",black)
				screen:print(259,67,menu[2],black)
				screen:print(254,77,"Tile placing",black)
				screen:print(259,87,menu[3],black)
				screen:print(254,97,"Selection tile",black)
				screen:print(259,107,menu[4],black)
				screen:print(259,27+(v_selection*20),menu[v_selection],red)

				screen:print(254,117,"__________________________",black)

				screen:print(254,137,"Puzzles:"..puzzles,black)

				--handling the user input
				--editing config values
				if ((pad:right() ~= oldpad:right()) and pad:right()) and menu_hor[v_selection] < menu_n[v_selection] then
					menu_hor[v_selection] = menu_hor[v_selection] + 1
				end
				if ((pad:left() ~= oldpad:left()) and pad:left()) and menu_hor[v_selection] > 1 then
					menu_hor[v_selection] = menu_hor[v_selection] - 1
				end
				--jumping in config
				if ((pad:up() ~= oldpad:up()) and pad:up()) and v_selection > 1 then
					v_selection = v_selection - 1
				end
				if ((pad:down() ~= oldpad:down()) and pad:down()) and v_selection < table.getn(menu) then
					v_selection = v_selection + 1
				end
				--switching puzzle selection
				if ((pad:l() ~= oldpad:l()) and pad:l()) and selection > 1 then
					selection = selection - 1
				end
				if ((pad:r() ~= oldpad:r()) and pad:r()) and selection < puzzles2load then
					selection = selection + 1
				end
				--switching pages
				if ((pad:circle() ~= oldpad:circle()) and pad:circle()) and pages > load_start then
					load_start = load_start + 1
					load_custom = 1
					if load_start == pages and ((load_start-1)*5)+selection > puzzles then
						selection = puzzles - ((load_start-1)*5)
					end
				end
				if ((pad:triangle() ~= oldpad:triangle()) and pad:triangle()) and load_start > 1 then
					load_start = load_start - 1
					load_custom = 1
				elseif ((pad:triangle() ~= oldpad:triangle()) and pad:triangle()) and load_start == 1 then
					mode = 4
					create_mode = 1
					load_custom = 1
					screen:clear(white)
					screen.flip()
					break
				end

				--selecting a puzzle for play mode !
				if ((pad:cross() ~= oldpad:cross()) and pad:cross()) then
					mode = 2
					load_file = 1
					puzzle2play = (((load_start-1)*5)+selection)
					screen:clear(white)
					screen.flip()
					break
				end
				--deleting a puzzle
				if ((pad:select() ~= oldpad:select()) and pad:select()) then

					puzzle2delete = (((load_start-1)*5)+selection)
					mode = 5
					screen:clear(white)
					screen.flip()
					break

				end
				--selecting a puzzle for play mode ! And loading
				if ((pad:square() ~= oldpad:square()) and pad:square()) then

					puzzle2play  = (((load_start-1)*5)+selection)
					puzzle_number = puzzle_data[puzzle2play]

					file 	     = "Saves/s"..puzzle_number.."/"..n_tiles[menu_hor[1]].."-"..n_tiles[menu_hor[2]]..".sav"
					if io.open(file, "r") then
						mode 	     = 2
						load_file    = 2
						screen:clear(white)
						screen.flip()
						break
					else
					end
				end

				if pad:start() then
					mode = 6
					break
				end

			end

			screen.flip()

			oldpad = pad
		end

	--solve a puzzle.. wow >_>
	elseif mode == 2 then
			screen:clear(white)
			pad = Controls.read()

			if load_mode == 1 then

				puzzle_background = Image.load("Img/background_puzzle.png")
				puzzle_number	  = puzzle_data[puzzle2play]
				puzzle_x	  = n_tiles[menu_hor[1]]
				puzzle_y	  = n_tiles[menu_hor[2]]
				puzzle_img	  = Image.load("Img/puzzles/p"..puzzle_number..".png")

				puzzle_block_x 	  = puzzle_img:width() / puzzle_x
				puzzle_block_y 	  = puzzle_img:height() / puzzle_y

				puzzle_raw 	  = {}	

				ii = 1

				for i=1,puzzle_x do
				for i1=1,puzzle_y do
					puzzle_raw[ii] = Image.createEmpty((puzzle_img:width()/puzzle_x),(puzzle_img:height()/puzzle_y))
					puzzle_raw[ii]:blit(0,0,puzzle_img,((i-1)*puzzle_img:width()/puzzle_x),((i1-1)*puzzle_img:height()/puzzle_y),(puzzle_img:width()/puzzle_x),(puzzle_img:height()/puzzle_y))
					ii = ii + 1					
				end
				end
				Finished_first = Image.createEmpty((puzzle_img:width()/puzzle_x),(puzzle_img:height()/puzzle_y))
				Finished_first:blit(0,0,puzzle_raw[1],0,0,puzzle_raw[1]:width(),puzzle_raw[1]:height())

				--creating the moving tile
				if menu_hor[4] == 1 then
					puzzle_raw[1]:clear()
				elseif menu_hor[4] == 2 then
					puzzle_raw[1]:clear()
					puzzle_raw[1]:blit(3,3,Finished_first,3,3,(Finished_first:width())-6,(Finished_first:height())-6)
				end
				--spaced puzzle mode, or not ?
				if menu_hor[3] == 1 then
					y_spacer     = 0
					x_spacer     = 0
					blit_spacer  = 0
				elseif menu_hor[3] == 2 then
					y_spacer     = (puzzle_y - 1)
					x_spacer     = (puzzle_x - 1)
					blit_spacer  = 2
				elseif menu_hor[3] == 3 then
					
					y_spacer     = math.floor(puzzle_y/2)
					x_spacer     = math.floor(puzzle_x/2)
					blit_spacer  = 1
				end			


				--should be scramble it ourselfs or load a file ?
				if load_file == 1 then
					random = {}
					for i=1,(puzzle_x*puzzle_y) do
						random[i] = i
					end
					puzzle_tiles = {}
					randfactor = 0
					for i=1,puzzle_x do
						puzzle_tiles[i] = {}
						for i1=1,puzzle_y do
							if i == 1 and i1 == 1 then
								puzzle_tiles[i][i1] = 1
							else
								rand = math.random(2,((puzzle_x*puzzle_y)-randfactor))
								puzzle_tiles[i][i1] = random[rand]
								table.remove(random, rand)
								randfactor = randfactor + 1
							end
						end
					end
					moves 		= 0
					cursor_x 	= 1
					cursor_y 	= 1

					file 	     	= "Saves/s"..puzzle_number.."/"..n_tiles[menu_hor[1]].."-"..n_tiles[menu_hor[2]]..".sav"
					f		= io.open(file, "r")
					if f then
						load_data = loadfile(file)

						puzzle_time1 	= tonumber(load_data[(table.getn(load_data)-3)])
						puzzle_time2 	= tonumber(load_data[(table.getn(load_data)-4)])
						puzzle_time3 	= tonumber(load_data[(table.getn(load_data)-5)])

						f:close()

					else
						puzzle_time1 	= 0
						puzzle_time2 	= 0
						puzzle_time3 	= 0
					end

					t1 = os.time()

					-- file wasnt loaded
					fl = "n"

				elseif load_file == 2 then
					load_data = loadfile("Saves/s"..puzzle_number.."/"..n_tiles[menu_hor[1]].."-"..n_tiles[menu_hor[2]]..".sav")
					runner = 1
					puzzle_tiles = {}
					for i=1,puzzle_x do
						puzzle_tiles[i] = {}
						for i1=1,puzzle_y do
							--if string.len(load_data[runner]) > 2 then
							--	puzzle_tiles[i][i1] = string.sub(load_data[runner],1,-2)
							--else
								puzzle_tiles[i][i1] = load_data[runner]
							--end
							runner = runner + 1
						end
					end
					moves    	= load_data[table.getn(load_data)]
					cursor_x 	= tonumber(load_data[(table.getn(load_data)-2)])
					cursor_y 	= tonumber(load_data[(table.getn(load_data)-1)])
					puzzle_time1 	= tonumber(load_data[(table.getn(load_data)-3)])
					puzzle_time2 	= tonumber(load_data[(table.getn(load_data)-4)])
					puzzle_time3 	= tonumber(load_data[(table.getn(load_data)-5)])
					puzzle_time 	= tonumber(load_data[(table.getn(load_data)-6)])
					
					t1 = os.time() - tonumber(puzzle_time)

					--file was loaded !
					fl = "y"

				end

				tilenumber = 1
				controle = {}
				for i=1,puzzle_x do
					controle[i] = {}
					for i1=1,puzzle_y do
						controle[i][i1] = tilenumber
						tilenumber = tilenumber + 1
					end
				end

				load_mode = 2

			elseif load_mode == 2 then


				screen:blit(0,0,puzzle_background,true)

				--checking wether the puzzle is complete or not !
				notdone = 1
				for i=1,puzzle_x do
					for i1=1,puzzle_y do
						if tonumber(controle[i][i1]) == tonumber(puzzle_tiles[i][i1]) then else notdone = 2 end
					end
				end

				if notdone == 1 then
				-- the puzzle is completed.. freeze the time

					if fl == "y" then
						timeform = puzzle_time
					end

					timeform = timeform
					t1 = os.time() - timeform

					timeforbesttime = timeform

					if not pad:select() then
						screen:blit(110-x_spacer,6-y_spacer,Finished_first,true)
					end

				elseif notdone == 2 then
				-- puzzle is still going strong, let time resume

					timeform = os.time()-t1

					timeforbesttime = 0

				end

				fl = "n"

				screen:print(0,262,"Free ram: "..System.getFreeMemory(),black)
				screen:print(10,10,"Moves Made",black)
				screen:print(10,20,moves,black)
				screen:print(10,30,"Time",black)
				screen:print(10,40,timeplayed(timeform),black)
				--screen:print(10,40,"00.02.89",black)

				screen:print(10,64,"Best Times",black)
				screen:print(10,74,timeplayed(puzzle_time1),black)
				screen:print(10,84,timeplayed(puzzle_time2),black)
				screen:print(10,94,timeplayed(puzzle_time3),black)

				--showing the.. puzzle !
				if pad:select() or pad:r() or pad:l() then
					screen:blit(110,6,puzzle_img,true)
				else
					--blitting the puzzle fragments !
					for i=1,puzzle_x do
					for i1=1,puzzle_y do
						if notdone == 1 and (i == 1 and i2 == 1) then
						else
							screen:blit((((i-1)*((260/puzzle_x)+blit_spacer))+110)-x_spacer,(((i1-1)*((260/puzzle_y)+blit_spacer))+6)-y_spacer,puzzle_raw[tonumber(puzzle_tiles[i][i1])],true)
						end
						--screen:print(((i-1)*(260/puzzle_x))+110,((i1-1)*(260/puzzle_y))+6,puzzle_tiles[i][i1],black)
						--screen:print(((i-1)*(260/puzzle_x))+110,((i1-1)*(260/puzzle_y))+16,controle[i][i1],black)
					end
					end

					if ((pad:down() ~= oldpad:down()) and pad:down()) and cursor_y < tonumber(puzzle_y) then
						old = puzzle_tiles[cursor_x][cursor_y]
						new = puzzle_tiles[cursor_x][cursor_y+1]
						puzzle_tiles[cursor_x][cursor_y+1] = old
						puzzle_tiles[cursor_x][cursor_y] = new
						cursor_y = cursor_y + 1
						moves = moves + 1
					end
					if ((pad:up() ~= oldpad:up()) and pad:up()) and cursor_y > 1 then
						old = puzzle_tiles[cursor_x][cursor_y]
						new = puzzle_tiles[cursor_x][cursor_y-1]
						puzzle_tiles[cursor_x][cursor_y-1] = old
						puzzle_tiles[cursor_x][cursor_y] = new
						cursor_y = cursor_y - 1
						moves = moves + 1
					end
					if ((pad:left() ~= oldpad:left()) and pad:left()) and cursor_x > 1 then
						old = puzzle_tiles[cursor_x][cursor_y]
						new = puzzle_tiles[cursor_x-1][cursor_y]
						puzzle_tiles[cursor_x-1][cursor_y] = old
						puzzle_tiles[cursor_x][cursor_y] = new
						cursor_x = cursor_x - 1
						moves = moves + 1
					end
					if ((pad:right() ~= oldpad:right()) and pad:right()) and cursor_x < tonumber(puzzle_x) then
						old = puzzle_tiles[cursor_x][cursor_y]
						new = puzzle_tiles[cursor_x+1][cursor_y]
						puzzle_tiles[cursor_x+1][cursor_y] = old
						puzzle_tiles[cursor_x][cursor_y] = new
						cursor_x = cursor_x + 1
						moves = moves + 1
					end
				end

				--Saving the puzzle
				if ((pad:square() ~= oldpad:square()) and pad:square()) then
					mode = 3
					screen:clear(white)
					screen.flip()
				end

				--Back to puzzle select !
				if ((pad:triangle() ~= oldpad:triangle()) and pad:triangle()) then
					mode = 1
					load_mode = 1
				end
			end


			screen.flip()

			oldpad = pad
	--saving the puzzle !
	elseif mode == 3 then

		-- The directory for the savefile doesn't exist yet: create it damn you !
		if not System.listDirectory("Saves/s"..puzzle_number) then
			System.createDirectory("Saves/s"..puzzle_number)
		end

		file = "Saves/s"..puzzle_number.."/"..n_tiles[menu_hor[1]].."-"..n_tiles[menu_hor[2]]..".sav"

		local f = assert(io.open(file, "w"))

		for i=1,puzzle_x do
		for i1=1,puzzle_y do
			towrite = puzzle_tiles[i][i1].."\r\n"
			f:write(towrite)
		end
		end

		if timeforbesttime > 0 then
			if timeforbesttime < puzzle_time1 or puzzle_time1 == 0 then
				puzzle_time3 = puzzle_time2
				puzzle_time2 = puzzle_time1
				puzzle_time1 = timeforbesttime
			elseif (puzzle_time2 == 0 and timeforbesttime > puzzle_time1) or (puzzle_time2 > 0 and timeforbesttime < puzzle_time2) or (puzzle_time2 == timeforbesttime)  then
				puzzle_time3 = puzzle_time2
				puzzle_time2 = timeforbesttime
			elseif (puzzle_time3 == 0 and timeforbesttime > puzzle_time2) or (puzzle_time3 > 0 and timeforbesttime < puzzle_time3 and timeforbesttime > puzzle_time2) or (puzzle_time3 == timeforbesttime)  then
				puzzle_time3 = timeforbesttime
			end
		end

		towrite = timeform .. "\r\n" .. puzzle_time3 .. "\r\n" .. puzzle_time2 .. "\r\n" .. puzzle_time1 .. "\r\n" .. cursor_x .. "\r\n" .. cursor_y .. "\r\n" .. moves
		f:write(towrite)		
	
		f:close()	

		savefileyn[selection] = "yes"
		
		mode = 2

	--creating an custom puzzle by loading an image !
	elseif mode == 4 then

		--selecting and Image to use as a base
		if create_mode == 1 then

			old_path = System.currentDirectory()

			System.currentDirectory("ms0:/")

			fl=System.listDirectory()
			nf=table.getn(fl)

			use_ka = Image.createEmpty(245,10)
			use_ka:clear(white)
			use_ka:print(1,1,"Use this Image ? O = y/ /\\ = n",black)

			oldpad = Controls.read()

			s 		= 1

			start_files	= 1
			files_per_page	= 22
			files_on_c_page = 22

			img_show_x 	= 0
			img_show_y 	= 0

			image_show_m 	= 1

			while true do

				pad = Controls.read()

				screen:clear(white)
				screen:blit(0,0,background_create,true)

				screen:print(15,18,string.sub(System.currentDirectory(),4,-1),black)

				--screen:print(15,40,"IK BEN EEN FILE",black)


				if s > files_on_c_page and (s-1)+start_files < nf then
					s = 1
					start_files = start_files + files_per_page
				elseif s > files_on_c_page and (s-1)+start_files > nf then
					s = 1
					start_files = 1
				elseif s < 1 and start_files > 1 then
					start_files = start_files - files_per_page
					s = files_per_page
				elseif s < 1 and start_files == 1 then
					start_files = (math.floor(nf/files_per_page)*files_per_page)+1
					s = nf - start_files+1
				end

				if (start_files-1)+files_per_page > nf then
					nf_dif = nf - start_files
					files_on_c_page = nf_dif + 1
				else
					files_on_c_page = files_per_page
				end

				--printcontentsofdirectoryp art--
				for i=1,files_on_c_page do
					screen:print(16,30+(i*10),string.sub(fl [(i-1)+start_files].name,1,56),white)
				end				


				--printcurrentselectedfilei nyellowpart--
				screen:print(16,(10*s)+30,string.sub(fl [(start_files+s)-1].name,1,56),yellow)
	
				--exitpart--
				if pad:select() then
					System.currentDirectory(old_path)
					mode = 1
					break 
				end
				--viewimagepart--
				if (pad:cross() and oldpad:cross() ~= pad:cross()) and fl[(start_files+s)-1].directory == false then


					if string.sub(fl[(start_files+s)-1].name, -4) == ".png" or string.sub(fl[(start_files+s)-1].name, -4) == ".jpg" or string.sub(fl[(start_files+s)-1].name, -4) == ".PNG" or string.sub(fl[(start_files+s)-1].name, -4) == ".JPG" then
						img_c = Image.load(fl[(start_files+s)-1].name)
					end
					image_show_m = 2

				end

				if image_show_m == 1 then

					--changeselectorpart--
					if pad:down() and oldpad:down() ~= pad:down() then s = s + 1 end
					if pad:up() and oldpad:up() ~= pad:up() then s = s - 1 end

				elseif image_show_m == 2 then

					if (pad:triangle() and oldpad:triangle() ~= pad:triangle()) then
						image_show_m = 1
					end

					if (pad:circle() and oldpad:circle() ~= pad:circle()) then
						image_show_m = 1
						create_mode = 2
						break
					end

					if pad:left() then
						img_show_x = img_show_x - 1
					elseif pad:right() then
						img_show_x = img_show_x + 1
					elseif pad:up() then
						img_show_y = img_show_y - 1
					elseif pad:down() then
						img_show_y = img_show_y + 1
					end

					screen:clear()
					screen:blit(img_show_x,img_show_y,img_c,true)
					screen:blit(0,0,use_ka,true)

				end

				--gointoselecteddirpart--
				if pad:cross() and oldpad:cross() ~= pad:cross() and fl[(start_files+s)-1].directory == true then
					System.currentDirectory(fl[(start_files+s)-1].name)
					s = 1
					fl=System.listDirectory()
					nf=table.getn(fl)
				end

				screen.flip()

				oldpad = pad

			end

		--using the selection image to cut out thumbnails and the final puzzle.. taihen desu.. 
		elseif create_mode == 2 then

			img_show_x 	= 0
			img_show_y 	= 0
			select_thumb_x 	= 0
			select_thumb_y 	= 0
			select_puzzle_x = 0
			select_puzzle_y = 0
			select_select_x = 0
			select_select_y = 0

			select_select = Image.createEmpty(200,23)
			select_select:clear(white_1)
			select_puzzle = Image.createEmpty(262,262)
			select_puzzle:clear(white_1)
			select_thumb  = Image.createEmpty(206,118)
			select_thumb:clear(white_1)

			screen_koreok = Image.createEmpty(480,272)

			use_ka = Image.createEmpty(260,10)
			use_ka:clear(white)
			use_ka:print(1,1,"Save these Images? O = y/ /\\ = n",black)

			oldpad = Controls.read()

			while true do
				screen:clear(white)
				screen_koreok:clear(white)
				pad = Controls.read()

				screen_koreok:blit(img_show_x,img_show_y,img_c,true)

				select_select:blit(1,1,screen_koreok,select_select_x+1,select_select_y+1,198,21)
				select_puzzle:blit(1,1,screen_koreok,select_puzzle_x+1,select_puzzle_y+1,260,260)
				select_thumb:blit(1,1,screen_koreok,select_thumb_x+1,select_thumb_y+1,204,116)

				screen:blit(0,0,screen_koreok,true)

				screen:blit(select_puzzle_x,select_puzzle_y,select_puzzle,true)
				screen:blit(select_thumb_x,select_thumb_y,select_thumb,true)
				screen:blit(select_select_x,select_select_y,select_select,true)

				if pad:up() and pad:l() and pad:r() then
					select_select_y = select_select_y - 1
				elseif pad:down() and pad:l() and pad:r() then
					select_select_y = select_select_y + 1
				elseif pad:right() and pad:l() and pad:r() then
					select_select_x = select_select_x + 1
				elseif pad:left() and pad:l() and pad:r() then
					select_select_x = select_select_x - 1

				elseif pad:up() and pad:r() then
					select_thumb_y = select_thumb_y - 1
				elseif pad:down() and pad:r() then
					select_thumb_y = select_thumb_y + 1
				elseif pad:right() and pad:r() then
					select_thumb_x = select_thumb_x + 1
				elseif pad:left() and pad:r() then
					select_thumb_x = select_thumb_x - 1

				elseif pad:up() and pad:l() then
					select_puzzle_y = select_puzzle_y - 1
				elseif pad:down() and pad:l() then
					select_puzzle_y = select_puzzle_y + 1
				elseif pad:right() and pad:l() then
					select_puzzle_x = select_puzzle_x + 1
				elseif pad:left() and pad:l() then
					select_puzzle_x = select_puzzle_x - 1

				elseif pad:up() then
					img_show_y = img_show_y - 1
				elseif pad:down() then
					img_show_y = img_show_y + 1
				elseif pad:right() then
					img_show_x = img_show_x + 1
				elseif pad:left() then
					img_show_x = img_show_x - 1

				elseif (pad:circle() and oldpad:circle() ~= pad:circle()) then
					create_mode = 3
					System.currentDirectory(old_path)
					break
				elseif (pad:triangle() and oldpad:triangle() ~= pad:triangle()) then
					create_mode = 1
					break
				end

				screen:blit(0,0,use_ka,true)

				screen.flip()

				if pad:start() then
					create_mode = 1
					break
				end		

				oldpad = pad

			end


			

		--saving the cutouts and going back to normal mode
		elseif create_mode == 3 then

			loadinput()

			img2b_puzzle = Image.createEmpty(260,260)
			img2b_puzzle:clear(white)
			img2b_puzzle:blit(0,0,screen_koreok,select_puzzle_x+1,select_puzzle_y+1,260,260)
			img2b_thumb  = Image.createEmpty(204,116)
			img2b_thumb:clear(white)
			img2b_thumb:blit(0,0,screen_koreok,select_thumb_x+1,select_thumb_y+1,204,116)
			img2b_select = Image.createEmpty(198,21)
			img2b_select:clear(white)
			img2b_select:blit(0,0,screen_koreok,select_select_x+1,select_select_y+1,198,21)

			name_okka 	 = 1
			edit_mode 	 = 1
			inputole  	 = ""
			oldpad 	  	 = Controls.read()
			upper 		 = 0
			string_2_print_x = ""

			while true do

				screen:clear(white)
				screen:blit(0,0,background_create,true)
				pad = Controls.read()

				--let the user input a name for the puzzle
				if name_okka == 1 then

					screen:print(15,18,"Name of the Puzzle (Press 'select' to input)",black)
					screen:print(15,40,inputole,yellow)
					screen:print(15,60,string_2_print_x,black)
					screen:print(15,70,"Press X to confirm",black)

					if (pad:select() and oldpad:select() ~= pad:select()) then
						edit_mode = edit_mode + 1
						if edit_mode > 2 then edit_mode = 1 end
					end

					--onscreen inputboard isnt showing
					if edit_mode == 1 then
						if (pad:triangle() and oldpad:triangle() ~= pad:triangle()) then
							create_mode = 2
							create_away = 2
							break
						end
						if (pad:cross() and oldpad:cross() ~= pad:cross()) and string.len(inputole) > 0 then
							name_okka = 2
						end
					--onscreen inputboard is a go!
					elseif edit_mode == 2 then
						inputole = input(inputole,358,153)
					end

				--check wether the name exists if not: break, save the puzzle and exit back to the main screen
				elseif name_okka == 2 then

					if in_table(puzzle_data,inputole) == 0 then
						--we've got an ok !
						name_okka = 1
						create_away = 1
						screen:clear(white)
						screen.flip()
						break
					elseif in_table(puzzle_data,inputole) == 1 then
						--bestaat al ouwuh >_>
						name_okka = 1
						string_2_print_x = "There already is a puzzle with this name"
					end

				end

				screen.flip()

				oldpad = pad

			end

			if create_away == 1 then

				-- The directory for the savefile doesn't exist yet: create it damn you !
				if not System.listDirectory("Saves/s"..inputole) then
				System.createDirectory("Saves/s"..inputole)
				end

				img2b_puzzle:save("Img/puzzles/p"..string.lower(inputole..".png"))
				img2b_select:save("Img/selection/s"..string.lower(inputole..".png"))
				img2b_thumb:save("Img/thumb/t"..string.lower(inputole..".png"))

				file = "puzzles.txt"

				local f = assert(io.open(file, "w"))

				for i=1,table.getn(puzzle_data) do
					towrite = puzzle_data[i] .. "\r\n"
					f:write(towrite)
				end			

				towrite = string.lower(inputole)
				f:write(towrite)

				f:close()

				puzzle_data 	  = openfile("puzzles.txt")
				puzzles     	  = numb_puzzles(puzzle_data)

				create_mode 	= 1
				mode 		= 1

				img2b_puzzle  = nil
				img2b_select  = nil
				img2b_thumb   = nil
				select_thumb  = nil
				select_select = nil
				select_puzzle = nil
				screen_koreok = nil

			end			
		end

	--delete a puzzle
	elseif mode == 5 then

			victim_name	  = puzzle_data[puzzle2delete]

			System.removeDirectory("Saves/s"..victim_name)

			System.removeFile("Img/puzzles/p"..victim_name..".png")
			System.removeFile("Img/selection/s"..victim_name..".png")
			System.removeFile("Img/thumb/t"..victim_name..".png")

			table.remove(puzzle_data,puzzle2delete)

			file = "puzzles.txt"

			local f = assert(io.open(file, "w"))

			for i=1,table.getn(puzzle_data)-1 do
				towrite = puzzle_data[i] .. "\r\n"
				f:write(towrite)
			end			

			towrite = puzzle_data[table.getn(puzzle_data)]
			f:write(towrite)

			f:close()			

			puzzle_data 	  = openfile("puzzles.txt")
			puzzles     	  = numb_puzzles(puzzle_data)

			selection = selection - 1
			if selection < 1 then
				selection = 5
				load_start = load_start - 1
			end

			load_custom = 1

			mode 		  = 1

	--exit this joint
	elseif mode == 6 then
		break
	end

end
